# Class TrimmedPartLayout

java.lang.Object
org.eclipse.swt.widgets.Layout
org.eclipse.e4.ui.workbench.renderers.swt.TrimmedPartLayout

public class TrimmedPartLayout extends Layout
This arranges its controls into 5 'slots' defined by its composite children

1. Top: spans the entire width and abuts the top of the container
2. Bottom: spans the entire width and abuts the bottom of the container
3. Left: spans the space between 'top' and 'bottom' and abuts the left of the container
4. Right: spans the space between 'top' and 'bottom' and abuts the right of the container
5. Center: fills the area remaining once the other controls have been positioned

NOTE: All the child controls must exist. Also, computeSize is not implemented because we expect this to be used in situations (i.e. shells) where the outer bounds are always 'set', not computed. Also, the interior structure of the center may contain overlapping controls so it may not be capable of performing the calculation.

Author:
  emoffatt

## Field Summary

Fields
Modifier and Type
Field
Description
`Composite`
`bottom`
`Composite`
`clientArea`
`int`
`gutterBottom`
gutterBottom specifies the number of pixels of vertical margin that will be placed between the bottom trim component and the bottom edge of the client area.
`int`
`gutterLeft`
gutterLeft specifies the number of pixels of horizontal margin that will be placed between the left trim component and the left edge of the client area.
`int`
`gutterRight`
gutterRight specifies the number of pixels of horizontal margin that will be placed between the right trim component and the right edge of the client area.
`int`
`gutterTop`
gutterTop specifies the number of pixels of vertical margin that will be placed between the top trim component and the top edge of the client area.
`Composite`
`left`
`Composite`
`right`
`Composite`
`top`

## Constructor Summary

Constructors
Constructor
Description
`TrimmedPartLayout(Composite parent)`
This layout is used to support parts that want trim for their containing composites.

## Method Summary

Modifier and Type
Method
Description
`protected Point`
`computeSize(Composite composite, int wHint, int hHint, boolean flushCache)`
Computes and returns the size of the specified composite's client area according to this layout.
`Composite`
`getTrimComposite(Composite parent, int side)`
`Rectangle`
`getTrimRect(int side)`
`protected void`
`layout(Composite composite, boolean flushCache)`
Lays out the children of the specified composite according to this layout.

### Methods inherited from class Layout

`flushCache`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### gutterBottom

public int gutterBottom
gutterBottom specifies the number of pixels of vertical margin that will be placed between the bottom trim component and the bottom edge of the client area. If there is no bottom trim component, the gutter serves as a margin. The default value is 0.

### gutterLeft

public int gutterLeft
gutterLeft specifies the number of pixels of horizontal margin that will be placed between the left trim component and the left edge of the client area. If there is no left trim component, the gutter serves as a margin. The default value is 0.

### gutterTop

public int gutterTop
gutterTop specifies the number of pixels of vertical margin that will be placed between the top trim component and the top edge of the client area. If there is no top trim component, the gutter serves as a margin. The default value is 0.

### gutterRight

public int gutterRight
gutterRight specifies the number of pixels of horizontal margin that will be placed between the right trim component and the right edge of the client area. If there is no right trim component, the gutter serves as a margin. The default value is 0.

### top

public Composite top

### bottom

public Composite bottom

### left

public Composite left

### right

public Composite right

### clientArea

public Composite clientArea

## Constructor Details

### TrimmedPartLayout

public TrimmedPartLayout(Composite parent)
This layout is used to support parts that want trim for their containing composites.

## Method Details

### computeSize

protected Point computeSize(Composite composite, int wHint, int hHint, boolean flushCache)
Description copied from class: `Layout`
Computes and returns the size of the specified composite's client area according to this layout.

This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

Specified by:
  `computeSize` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `wHint` - width (`SWT.DEFAULT` for preferred size)
  `hHint` - height (`SWT.DEFAULT` for preferred size)
  `flushCache` - `true` means flush cached layout values
Returns:
  a point containing the computed size (width, height)
See Also:
  - `Layout.layout(Composite, boolean)`
  - `Control.getBorderWidth()`
  - `Control.getBounds()`
  - `Control.getSize()`
  - `Control.pack(boolean)`
  - "computeTrim, getClientArea for controls that implement them"

### layout

protected void layout(Composite composite, boolean flushCache)
Description copied from class: `Layout`
Lays out the children of the specified composite according to this layout.

This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

Specified by:
  `layout` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `flushCache` - `true` means flush cached layout values

### getTrimComposite

public Composite getTrimComposite(Composite parent, int side)

### getTrimRect

public Rectangle getTrimRect(int side)